from kdeui import PyKPanelApplet, KPanelApplet
from qt import QColor, QFrame


# Any panel applet written in Python must include THIS "factory" function
# The name must be createApplet, and it must take the two args shown; it
# must return a PyKPanelApplet subclass
def createApplet (parent, configFile):
    return DemoPanelApplet (configFile, KPanelApplet.Normal, 0, parent, "demo")


# Define the PyKPanelApplet subclass in a fashion similar to this
# (PyKPanelApplet is a subclass of KPanelApplet, and exposes all of
# KPanelApplet's methods)
class DemoPanelApplet (PyKPanelApplet):
    def __init__  (self, configFile, t, actions, parent, name, f = 0):
        PyKPanelApplet.__init__ (self, configFile, t, actions, parent, name, f)
        self.setPaletteBackgroundColor(QColor (0x00, 0x00, 0xff))
        self.setFrameStyle( QFrame.StyledPanel | QFrame.Sunken )

    def widthForHeight (self, h):
        return h

    def heightForWidth (self, w ):
        return w
