/* copyright 2003 Jim Bublitz <jbublitz@nwinternet.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __testPythonize_h__
#define  __testPythonize_h__


class TestPythonize
{
public:
                        TestPythonize ();
                        ~TestPythonize ();

                        // bool appendToSysPath (const char* newPath);
        bool            testAppendToSysPath ();

                        //PyObject *importModule (char *moduleName);
        bool            testImportModule ();

                        //PyObject getObject (PyObject *module, char *object) { return PyObject_GetAttrString (module, object); }
                        // returns a new reference that must be decref'd
        bool            testGetNewObjectRef ();

                        // void runScript (char *scriptPath);
        bool            testRunScript ();

                        // bool runString (char *str);
        bool            testRunString ();

                        // ReturnStruct runFunction (PyObject *object, PyObject *args);
        bool            testRunFunction ();

        bool            testDtor ();


        bool            runTests ();
        void            reportResult (const char *test, bool result);

        bool            testInit;

private:
        int             failed;
        Pythonize       *pyize;
        PyObject        *impModule;
        PyObject        *pyAdd;
};

class TestPythonizeC
{
public:
                        TestPythonizeC ();
                        ~TestPythonizeC ();

                        // bool appendToSysPath (const char* newPath);
        bool            testAppendToSysPath ();

                        //PyObject *importModule (char *moduleName);
        bool            testImportModule ();

                        //PyObject getObject (PyObject *module, char *object) { return PyObject_GetAttrString (module, object); }
                        // returns a new reference that must be decref'd
        bool            testGetNewObjectRef ();

                        // void runScript (char *scriptPath);
        bool            testRunScript ();

                        // bool runString (char *str);
        bool            testRunString ();

                        // ReturnStruct runFunction (PyObject *object, PyObject *args);
        bool            testRunFunction ();

        bool            testDtor ();


        bool            runTests ();
        void            reportResult (const char *test, bool result);

        bool            testInit;

private:
        int             failed;
        Pythonize       *pyize;
        PyObject        *impModule;
        PyObject        *pyAdd;
};

#endif
